package arc.ex;


import android.app.Activity;
import android.content.Context;
//import android.content.Context;
import android.os.Bundle;
//import android.graphics.Color;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ToggleButton;
import arc.ex.ControlModule.CmException;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;


public class MainActivity extends Activity implements View.OnClickListener {
    /** Called when the activity is first created. */
		
	private TextView textScStatus, textCmConfig;     //eLXgr[
	private TextView textCmReceive, textMcdReceive;     //eLXgr[
    private EditText editCmId, editMcdId;
    private EditText editScVal, editCmVal, editMcdVal;
    private ToggleButton toggleDatkOpen;
    private CheckBox checkBoxCm, checkBoxMcd;
    private Button buttonBlink, buttonCtrl, buttonCmSet, buttonMcdSet;
    private Context context;
    
    SC02 scModule;
    CM01 cmModule;
    MCD05 mcdModule;

    boolean comLoop;
	public ComThread comThread;
	String str_output, str_input;
	int scVal, cmVal, mcdVal;
	int command;
	final int COM_STOP  = 0;
	final int COM_BLINK = 1;
	final int COM_CTRL  = 2;

    @Override
    public void onCreate(Bundle savedInstanceState) {
    	super.onCreate(savedInstanceState);
    	
        setContentView(R.layout.main);
        
 		getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
        textScStatus= (TextView) findViewById(R.id.textScStatus);
        textCmConfig= (TextView) findViewById(R.id.textCmConfig);
        
        textCmReceive= (TextView) findViewById(R.id.textCmReceive);
        textMcdReceive= (TextView) findViewById(R.id.textMcdReceive);
        
        editCmId = (EditText) findViewById(R.id.editCmId);
        editCmId.setText("1");
        editMcdId = (EditText) findViewById(R.id.editMcdId);
        editMcdId.setText("2");
        
        toggleDatkOpen= (ToggleButton)findViewById(R.id.toggleDatkOpen);
        toggleDatkOpen.setOnClickListener(this);
        
        checkBoxCm = (CheckBox)findViewById(R.id.checkBoxCm);
        checkBoxMcd = (CheckBox)findViewById(R.id.checkBoxMcd);
        
        editScVal = (EditText) findViewById(R.id.editScVal);
        editScVal.setText("3");
        editCmVal = (EditText) findViewById(R.id.editCmVal);
        editCmVal.setText("100");
        editMcdVal = (EditText) findViewById(R.id.editMcdVal);
        editMcdVal.setText("512");

        buttonBlink = (Button)findViewById(R.id.buttonBlink);
        buttonBlink.setOnClickListener(this);
        buttonBlink.setEnabled(false);
        buttonCtrl = (Button)findViewById(R.id.buttonCtrl);
        buttonCtrl.setOnClickListener(this);
        buttonCtrl.setEnabled(false);
        buttonCmSet = (Button)findViewById(R.id.buttonCmSet);
        buttonCmSet.setOnClickListener(this);
        buttonMcdSet = (Button)findViewById(R.id.buttonMcdSet);
        buttonMcdSet.setOnClickListener(this);
        
        context = this;
        
        scModule = new SC02( this );
        cmModule = new CM01();
        mcdModule = new MCD05();
        
        scVal = 3;
        cmVal = 100;
        mcdVal = 512;
        
        command = COM_STOP;
       	}
   
    
    @Override
   	protected void onDestroy() {
       	this.unregisterReceiver( scModule.mUsbReceiver);
       	super.onDestroy();
   	}
    
    @Override
	public void onStart()
	{
		super.onStart();
   	}
    
    //Av̊Jn
    @Override
    protected void onResume() {
        //Av̊Jn
        super.onResume();
        //Toast.makeText(this, "Resume", Toast.LENGTH_SHORT).show();
       
    }
    
    //Av̒~
    @Override
    protected void onStop() {
        //Av̒~
    	if( comLoop ){
    		comLoop = false;
        	try {
    			Thread.sleep(100);
    		} catch (InterruptedException e) {
    		}
    	}
    	
        super.onStop();
    }
    
    public void onClick( View view )
	{
    	String str;
    	
    	if( view == toggleDatkOpen ){
    		if( toggleDatkOpen.isChecked() ){
    			openDatk();
       		}else{
       			closeDatk();
        	}
    	}else if( view == buttonBlink){
			str = editScVal.getText().toString(); 
			scVal = Integer.parseInt(str);
    		command = COM_BLINK;
    	}else if( view == buttonCtrl){
    		if( command == COM_STOP ){
    			command = COM_CTRL;
    			buttonCtrl.setText("Stop");
    		}else{
       			command = COM_STOP;
    			buttonCtrl.setText("Ctrl");
    		}
    	}else if( view == buttonCmSet ){
       		str = editCmVal.getText().toString();
    		cmVal = Integer.parseInt(str);
    	}else if( view == buttonMcdSet ){
       		str = editMcdVal.getText().toString();
    		mcdVal = Integer.parseInt(str);
    	}
    	 	
	}
    
    void openDatk()
    {
        buttonBlink.setEnabled(true);
        buttonCtrl.setEnabled(true);
        checkBoxCm.setClickable(false);
        checkBoxMcd.setClickable(false);
        editCmId.setEnabled(false);
        editMcdId.setEnabled(false);
        
    	comThread = new ComThread();
    	comLoop = true;
    	comThread.start();
    }
    
    void closeDatk()
    {
    	if( comLoop ){
    		comLoop = false;
			try {
				Thread.sleep(300);
			}
			catch (InterruptedException e) {
				e.printStackTrace();
			}
    	}
    	
        buttonBlink.setEnabled(false);
        buttonCtrl.setEnabled(false);
        checkBoxCm.setClickable(true);
        checkBoxMcd.setClickable(true);
        editCmId.setEnabled(true);
        editMcdId.setEnabled(true);
    }
    
    void setTextScStatus( final String text )
   	{
           runOnUiThread(new Runnable() { 
               @Override 
               public void run() { 
               	textScStatus.setText( text ); 
               } 
           }); 
   	}
    
    void setTextCmConfig( final String text )
   	{
           runOnUiThread(new Runnable() { 
               @Override 
               public void run() { 
               	textCmConfig.setText( text ); 
               } 
           }); 
   	}
       
    void setTextCmReceive( final String text )
   	{
           runOnUiThread(new Runnable() { 
               @Override 
               public void run() { 
               	textCmReceive.setText( text ); 
               } 
           }); 
   	}

    void addTextCmReceive( final String text )
   	{
           runOnUiThread(new Runnable() { 
               @Override 
               public void run() { 
               	textCmReceive.append( text ); 
               }
           }); 
   	}
    
    void setTextMcdReceive( final String text )
   	{
           runOnUiThread(new Runnable() { 
               @Override 
               public void run() { 
               	textMcdReceive.setText( text ); 
               } 
           }); 
   	}

    void setToggleScOpenChecked( final boolean state )
   	{
           runOnUiThread(new Runnable() { 
               @Override 
               public void run() { 
            	   toggleDatkOpen.setChecked(state);
               } 
           }); 
   	}
    
    void showToast( final String text )
   	{
		runOnUiThread(new Runnable() { 
		@Override 
		public void run() {
			Toast.makeText( context, text, Toast.LENGTH_LONG).show();
			} 
		}); 
   	}


    // THread Ăяo
    void openCm() throws CmException
    {
    	String str;
    	int id;
    	
    	str = editCmId.getText().toString(); 
		id = Integer.parseInt(str);
		cmModule.open((ControlModule)scModule, 0, id );
		
		str = String.format("board id A=%d B=%d\n", cmModule.boardID_PA, cmModule.boardID_PB );
		str+= String.format("data size in %d out %d\n", cmModule.inputDataSize, cmModule.outputDataSize );
		setTextCmConfig( str );
		str = String.format("status %d", cmModule.status );
		setTextCmReceive( str );
		str = String.format("status %d", scModule.status);
        setTextScStatus( str );
        
        cmModule.clearData();
    }
    
    void openMcd() throws CmException
    {
    	String str;
    	int id;
    	
    	str = editMcdId.getText().toString(); 
		id = Integer.parseInt(str);
		mcdModule.open((ControlModule)scModule, 0, id );
		str = String.format("status %d", mcdModule.status );
		setTextMcdReceive( str );
		str = String.format("status %d", scModule.status);
        setTextScStatus( str );
        
        mcdModule.clearData();
    }
    
    void procCm() throws CmException
    {
    	String str = "";

    	// |[gB̃f[^ݒ
    	switch(  cmModule.boardID_PB ){
    	case CM01.PWM_BOARD:
    		cmModule.pwmBoard.pwm1 = (short)cmVal;
    		cmModule.pwmBoard.pwm2 = (short)cmVal;
    		str = String.format("pwm %d %d\n", cmModule.pwmBoard.pwm1, cmModule.pwmBoard.pwm2 );
    		break; 
    	case CM01.DA_BOARD:
    		cmModule.daBoard.da = (short)cmVal;
    		str = String.format("da %d\n", cmModule.daBoard.da );
    		break;
    	case CM01.PIO_BOARD:
    		cmModule.pioBoardB.data = (short)cmVal; //PIOB10bit܂ŗL
    		cmModule.pioBoardB.dir  = 0; // all output
    		str = String.format("pio B %04x\n", cmModule.pioBoardB.data );
    		break;
    	}
    	
		cmModule.exchange(true);
       	
		//str += String.format("status %d ", cmModule.status );
       	
        switch( cmModule.boardID_PA ){
    	case CM01.ENC_BOARD:
    		str += String.format("enc %d ad %d\n", cmModule.encBoard.encoder, cmModule.encBoard.sensor[0] );
    		break;
    	case CM01.SENSOR_BOARD:
    		str += String.format("sens %d  %d  %d  %d  %d  %d  %d  %d\n",
    			cmModule.sensorBoard.sensor[0], cmModule.sensorBoard.sensor[1],
    			cmModule.sensorBoard.sensor[2], cmModule.sensorBoard.sensor[3],
    			cmModule.sensorBoard.sensor[4], cmModule.sensorBoard.sensor[5],
    			cmModule.sensorBoard.sensor[6], cmModule.sensorBoard.sensor[7]
    		);
    		break;
    	case CM01.PIO_BOARD:
    		str += String.format( "pio A %04x\n", cmModule.pioBoardA.data );
    		break;
    	}
        
		setTextCmReceive( str );
    }
    
    void procMcd() throws CmException
    {
    	String str = "";
		long startTime, endTime;
    	
		mcdModule.outputData.pwm = (short)mcdVal;
		str = String.format("pwm %d\n", mcdModule.outputData.pwm );
		
		startTime = System.currentTimeMillis();
		
		mcdModule.exchange(true);
		
		endTime = System.currentTimeMillis();
		//str += String.format("status %d", mcdModule.status );
		str += String.format("enc %d", mcdModule.inputData.encoder );
		setTextMcdReceive( str );
		
		str = String.format("time %5d ms", endTime-startTime);
		setTextScStatus( str );
    }

    private class ComThread  extends Thread
	{
		@Override
		public void run()
		{
			String str;

			try{
				scModule.open();
				str = String.format("status %d", scModule.status);
	    		setTextScStatus( str );
	    		
		    	if( checkBoxCm.isChecked() ) openCm();
		    	if( checkBoxMcd.isChecked() ) openMcd();

				while( comLoop )
				{
					try {
						Thread.sleep(100);
					} catch (InterruptedException e) {
					}
		
					switch( command ){
					case COM_STOP:
						setTextCmReceive("Stop" );
						setTextMcdReceive("Stop" );
						break;
					case COM_BLINK:
						scModule.blink( scVal );
			    		
						if( cmModule.isOpen() )	cmModule.blink( scVal );
						if( mcdModule.isOpen() ) mcdModule.blink( scVal );
						command = COM_STOP;
						break;
					case COM_CTRL:
						if( cmModule.isOpen() )	procCm();
						if( mcdModule.isOpen() ) procMcd();
					}
				}
				
				if( cmModule.isOpen() ) cmModule.close();
				if( mcdModule.isOpen() ) mcdModule.close();
			}
			catch( CmException e ){
				setTextScStatus( String.format("status %d ", scModule.status ) );
				if( cmModule.isOpen() ) setTextCmReceive( String.format("status %d ", cmModule.status ) );
				if( mcdModule.isOpen() ) setTextMcdReceive( String.format("status %d ", mcdModule.status ) );
				
				showToast( e.getMessage() );
			}
			
	    	scModule.close();
		}

	}


       
    
}
    